AbstractClasspathResource (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: AbstractClasspathResource

# Class AbstractClasspathResource

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.AbstractClasspathResource

All Implemented Interfaces:
  `Cloneable, Comparable<Resource>, Iterable<Resource>, ResourceCollection`

Direct Known Subclasses:
  `JavaConstantResource, JavaResource`

public abstract class AbstractClasspathResource extends Resource
A Resource representation of anything that is accessed via a Java classloader. The core methods to set/resolve the classpath are provided.

Since:
  Ant 1.8.0

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `AbstractClasspathResource.ClassLoaderWithFlag`

- ## Field Summary

  ### Fields inherited from class Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`
  Modifier and Type
  Field
  Description
  `protected static final int`
  `MAGIC`
  Magic number
  `static final long`
  `UNKNOWN_DATETIME`
  Constant unknown datetime for getLastModified
  `static final long`
  `UNKNOWN_SIZE`
  Constant unknown size

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractClasspathResource()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Path`
  `createClasspath()`
  Add a classpath to use when looking up a resource.
  `protected void`
  `dieOnCircularReference(Stack<Object> stk, Project p)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected AbstractClasspathResource.ClassLoaderWithFlag`
  `getClassLoader()`
  combines the various ways that could specify a ClassLoader and potentially creates one that needs to be cleaned up when it is no longer needed so that classes can get garbage collected.
  `Path`
  `getClasspath()`
  get the classpath used by this `LoadProperties`.
  `InputStream`
  `getInputStream()`
  Return an InputStream for reading the contents of this Resource.
  `Reference`
  `getLoader()`
  Get the loader.
  `protected AbstractClasspathResource`
  `getRef()`
  Perform the check for circular references and return the referenced Resource.
  `boolean`
  `isExists()`
  Learn whether this resource exists.
  `protected abstract InputStream`
  `openInputStream(ClassLoader cl)`
  open the input stream from a specific classloader
  `void`
  `setClasspath(Path classpath)`
  Set the classpath to use when looking up a resource.
  `void`
  `setClasspathRef(Reference r)`
  Set the classpath to use when looking up a resource, given as reference to a <path> defined elsewhere
  `void`
  `setLoaderRef(Reference r)`
  Use the reference to locate the loader.
  `void`
  `setParentFirst(boolean b)`
  Whether to consult the parent classloader first.
  `void`
  `setRefid(Reference r)`
  Overrides the super version.

  ### Methods inherited from class Resource

  `as, asOptional, clone, compareTo, equals, getLastModified, getMagicNumber, getName, getOutputStream, getSize, hashCode, isDirectory, isFilesystemOnly, iterator, setDirectory, setExists, setLastModified, setName, setSize, size, toLongString, toString`
  Modifier and Type
  Method
  Description
  `<T> T`
  `as(Class<T> clazz)`
  Returns a view of this resource that implements the interface given as the argument or null if there is no such view.
  `<T> Optional<T>`
  `asOptional(Class<T> clazz)`
  Return `Resource.as(Class)` as an `Optional`.
  `Object`
  `clone()`
  Clone this Resource.
  `int`
  `compareTo(Resource other)`
  Delegates to a comparison of names.
  `boolean`
  `equals(Object other)`
  Implement basic Resource equality.
  `long`
  `getLastModified()`
  Tells the modification time in milliseconds since 01.01.1970 (the "epoch").
  `protected static int`
  `getMagicNumber(byte[] seed)`
  Create a "magic number" for use in hashCode calculations.
  `String`
  `getName()`
  Name attribute will contain the path of a file relative to the root directory of its fileset or the recorded path of a zip entry.
  `OutputStream`
  `getOutputStream()`
  Get an OutputStream for the Resource.
  `long`
  `getSize()`
  Get the size of this Resource.
  `int`
  `hashCode()`
  Get the hash code for this Resource.
  `boolean`
  `isDirectory()`
  Tells if the resource is a directory.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the ResourceCollection contract.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `void`
  `setDirectory(boolean directory)`
  Set the directory attribute.
  `void`
  `setExists(boolean exists)`
  Set the exists attribute.
  `void`
  `setLastModified(long lastmodified)`
  Set the last modification attribute.
  `void`
  `setName(String name)`
  Set the name of this Resource.
  `void`
  `setSize(long size)`
  Set the size of this Resource.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.
  `final String`
  `toLongString()`
  Get a long String representation of this Resource.
  `String`
  `toString()`
  Get the string representation of this Resource.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### AbstractClasspathResource

    public AbstractClasspathResource()

- ## Method Details

  - ### setClasspath

    public void setClasspath(Path classpath)
    Set the classpath to use when looking up a resource.
    Parameters:
      `classpath` - to add to any existing classpath

  - ### createClasspath

    public Path createClasspath()
    Add a classpath to use when looking up a resource.
    Returns:
      The classpath to be configured

  - ### setClasspathRef

    public void setClasspathRef(Reference r)
    Set the classpath to use when looking up a resource, given as reference to a <path> defined elsewhere
    Parameters:
      `r` - The reference value

  - ### getClasspath

    public Path getClasspath()
    get the classpath used by this `LoadProperties`.
    Returns:
      The classpath

  - ### getLoader

    public Reference getLoader()
    Get the loader.
    Returns:
      the loader.

  - ### setLoaderRef

    public void setLoaderRef(Reference r)
    Use the reference to locate the loader. If the loader is not found, taskdef will use the specified classpath and register it with the specified name.

    This allow multiple taskdef/typedef to use the same class loader, so they can be used together. It eliminate the need to put them in the CLASSPATH.

    Parameters:
      `r` - the reference to locate the loader.

  - ### setParentFirst

    public void setParentFirst(boolean b)
    Whether to consult the parent classloader first.

    Only relevant if a classpath has been specified.

    Parameters:
      `b` - boolean
    Since:
      Ant 1.8.0

  - ### setRefid

    public void setRefid(Reference r)
    Overrides the super version.
    Overrides:
      `setRefid` in class `Resource`
    Parameters:
      `r` - the Reference to set.

  - ### isExists

    public boolean isExists()
    Learn whether this resource exists. This implementation opens the input stream as the test.
    Overrides:
      `isExists` in class `Resource`
    Returns:
      true if this resource exists.

  - ### getInputStream

    public InputStream getInputStream() throws IOException
    Return an InputStream for reading the contents of this Resource.
    Overrides:
      `getInputStream` in class `Resource`
    Returns:
      an InputStream object.
    Throws:
      `IOException` - if an error occurs.

  - ### getClassLoader

    protected AbstractClasspathResource.ClassLoaderWithFlag getClassLoader()
    combines the various ways that could specify a ClassLoader and potentially creates one that needs to be cleaned up when it is no longer needed so that classes can get garbage collected.
    Returns:
      ClassLoaderWithFlag

  - ### openInputStream

    protected abstract InputStream openInputStream(ClassLoader cl) throws IOException
    open the input stream from a specific classloader
    Parameters:
      `cl` - the classloader to use. Will be null if the system classloader is used
    Returns:
      an open input stream for the resource
    Throws:
      `IOException` - if an error occurs.

  - ### dieOnCircularReference

    protected void dieOnCircularReference(Stack<Object> stk, Project p)
    Description copied from class: `DataType`
    Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    If one is included, throw a BuildException created by `circularReference`.

    This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

    The general contract of this method is that it shouldn't do anything if `DataType.checked` is true and set it to true on exit.

    Overrides:
      `dieOnCircularReference` in class `DataType`
    Parameters:
      `stk` - the stack of references to check.
      `p` - the project to use to dereference the references.

  - ### getRef

    protected AbstractClasspathResource getRef()
    Description copied from class: `Resource`
    Perform the check for circular references and return the referenced Resource.
    Overrides:
      `getRef` in class `Resource`
    Returns:
      `Resource`.